unit ch04;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
   Forms, Dialogs, OpenGL, SPF;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

var
 f_Hdc : LongInt;

procedure InitGL;	// All Setup For OpenGL Goes Here
begin
// select clearing color
   glClearColor( 1.0, 1.0, 1.0, 0);
   glShadeModel (GL_FLAT);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
end;

procedure drawOneLine(x1,y1,x2,y2 : single);
begin
  glBegin(GL_LINES);
    glVertex2f(x1,y1);  glVertex2f(x2,y2);
  glEnd();
end;

procedure DrawGLScene();
 // Here's Where We Do All The Drawing!!!
var i: integer;
begin
   glClear (GL_COLOR_BUFFER_BIT);
{/* select black for all lines  */}
   glColor3f (0.0, 0.0, 0.0);

   glLoadIdentity();
glEnable (GL_LINE_STIPPLE);
glLineStipple (1, $0101);  //  dotted
   for i:=-9 to 9 do
     begin
      drawoneline(i,-9,i,9);
      drawoneline(-9,i,9,i);
     end;
glDisable (GL_LINE_STIPPLE);

         glLoadIdentity();
        // Translate the object
        glTranslatef (-5, 5, 0);
        //Draw the verticies connected according to the GL_LINES primitive
        glBegin(GL_LINES);
                glVertex2f( -1, 1);  // Vertex 1
                glVertex2f( 2, 2);   // Vertex 2
                glVertex2f( 0, 0);   // Vertex 3
                glVertex2f( 1, -1);  // Vertex 4
                glVertex2f( -2, -2); // Vertex 5
        glEnd();

        glLoadIdentity();  //reset or going back to origin.
        glTranslatef (0, 5, 0);  // going to new origin.

        glBegin (GL_LINE_STRIP);
                glVertex2f (-1, 1); glVertex2f (2, 2);
                glVertex2f (0, 0);  glVertex2f (1, -1);
                glVertex2f (-2, -2);
        glEnd();

        glLoadIdentity();
        glTranslatef (5, 5, 0);

        glBegin (GL_LINE_LOOP);
                glVertex2f (-1, 1); glVertex2f (2, 2);
                glVertex2f (0, 0);  glVertex2f (1, -1);
                glVertex2f (-2, -2);
        glEnd();

        glLoadIdentity();
        glTranslatef (-5, 0, 0);

        glBegin (GL_POLYGON);
                glVertex2f (-1, 1); glVertex2f (2, 2);
                glVertex2f (0, 0);  glVertex2f (1, -1);
                glVertex2f (-2, -2);
        glEnd();

        glLoadIdentity();
        glTranslatef (0, 0, 0);

        glBegin (GL_QUADS);
                glVertex2f (-1, 1); glVertex2f (2, 2);
                glVertex2f (0, 0);  glVertex2f (1, -1);
                glVertex2f (-2, -2);
        glEnd();

        glLoadIdentity();
        glTranslatef (5, 0, 0);

        glBegin (GL_QUAD_STRIP);
                glVertex2f (-1, 1); glVertex2f (2, 2);
                glVertex2f (0, 0);  glVertex2f (1, -1);
                glVertex2f (-2, -2);
        glEnd();

        glLoadIdentity();
        glTranslatef (-5, -5, 0);

        glBegin (GL_TRIANGLES);
                glVertex2f (-1, 1); glVertex2f (2, 2);
                glVertex2f (0, 0);  glVertex2f (1, -1);
                glVertex2f (-2, -2);
        glEnd();

        glLoadIdentity();
        glTranslatef (0, -5, 0);

        glBegin (GL_TRIANGLE_STRIP);
                glVertex2f (-1, 1); glVertex2f (2, 2);
                glVertex2f (0, 0);  glVertex2f (1, -1);
                glVertex2f (-2, -2);
        glEnd();

        glLoadIdentity();
        glTranslatef (5, -5, 0);

        glBegin (GL_TRIANGLE_FAN);
                glVertex2f (-1, 1); glVertex2f (2, 2);
                glVertex2f (0, 0);  glVertex2f (1, -1);
                glVertex2f (-2, -2);
        glEnd ();

   glFlush ();
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Create a rendering context.
  f_Hdc := GetDC(handle);
  SetDCPixelFormat(f_Hdc,16,16);
  InitGL;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  CleanUp(f_Hdc);// Clean up and terminate.
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  wglMakeCurrent(f_Hdc,hrc); //activate the RC
  DrawGLScene;// Draw the scene.
end;

procedure TForm1.FormResize(Sender: TObject);
 begin
  // Redefine the viewing volume and viewport
  //when the window size changes.
   wglMakeCurrent(f_Hdc, hrc);
   // Now, set up the viewing area-select the full client area
   glViewport( 0, 0, Width , Height);
   // Choose the projection matrix to be the matrix
   // manipulated by the following calls
        glMatrixMode (GL_PROJECTION);
  // Set the projection matrix to be the identity matrix
        glLoadIdentity();
  // Define the dimensions of the Orthographic Viewing Volume
          glOrtho (-13, 13, -13, 13, -13, 13);
  //      gluOrtho2D(-9, 9, -9, 9);
  // Choose the modelview matrix to be the matrix
  // manipulated by further calls
        glMatrixMode (GL_MODELVIEW); // this is Necessary for glTranslatef !
   DrawGLScene();
 end;
end.
