unit alakiGL;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, OpenGL, SPF;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
 // hrc: HGLRC;  // Permanent Rendering Context
  fly : array[0..127] of GLubyte =(
      $00, $00, $00, $00, $00, $00, $00, $00,
      $03, $80, $01, $C0, $06, $C0, $03, $60,
      $04, $60, $06, $20, $04, $30, $0C, $20,
      $04, $18, $18, $20, $04, $0C, $30, $20,
      $04, $06, $60, $20, $44, $03, $C0, $22,
      $44, $01, $80, $22, $44, $01, $80, $22,
      $44, $01, $80, $22, $44, $01, $80, $22,
      $44, $01, $80, $22, $44, $01, $80, $22,
      $66, $01, $80, $66, $33, $01, $80, $CC,
      $19, $81, $81, $98, $0C, $C1, $83, $30,
      $07, $e1, $87, $e0, $03, $3f, $fc, $c0,
      $03, $31, $8c, $c0, $03, $33, $cc, $c0,
      $06, $64, $26, $60, $0c, $cc, $33, $30,
      $18, $cc, $33, $18, $10, $c4, $23, $08,
      $10, $63, $C6, $08, $10, $30, $0c, $08,
      $10, $18, $18, $08, $10, $00, $00, $08);

  halftone : array[0..127] of GLubyte =(
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55,
      $AA, $AA, $AA, $AA, $55, $55, $55, $55);

implementation
{$R *.DFM}

var
   f_Hdc : LongInt;

procedure InitGL;	// All Setup For OpenGL Goes Here
begin
// select clearing color
   glClearColor( 1.0, 1.0, 1.0, 0);
   glShadeModel (GL_FLAT);
end;

procedure drawOneLine(x1,y1,x2,y2 : single);
begin
  glBegin(GL_LINES);
    glVertex2f(x1,y1);  glVertex2f(x2,y2);
  glEnd();
end;

procedure DrawGLScene();
 // Here's Where We Do All The Drawing!!!
begin
   glClear (GL_COLOR_BUFFER_BIT);
{/* select black for all lines  */}
   glColor3f (0.0, 0.0, 0.0);

{/*  draw one solid, unstippled rectangle,       */
/*  then two stippled rectangles                */}
   glRectf (25.0, 25.0, 125.0, 125.0);
   glEnable (GL_POLYGON_STIPPLE);
   glPolygonStipple(@fly);
   glRectf (125.0, 25.0, 225.0, 125.0);
   glPolygonStipple (@halftone);
   glRectf (225.0, 25.0, 325.0, 125.0);
   glDisable (GL_POLYGON_STIPPLE);
 glFlush ();
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  f_Hdc := GetDC(handle);
  // Create a rendering context.
  SetDCPixelFormat(f_Hdc,16,16);
  InitGL;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  // Clean up and terminate.
  CleanUp(f_Hdc);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  // Draw the scene.
  wglMakeCurrent(f_Hdc,hrc); //activate the RC
  DrawGLScene;
end;

procedure TForm1.FormResize(Sender: TObject);
 begin
  // Redefine the viewing volume and viewport
  //when the window size changes.
   wglMakeCurrent(f_Hdc, hrc);
   // Now, set up the viewing area-select the full client area
     glViewport( 0, 0, Width , Height);
   // Choose the projection matrix to be the matrix
   // manipulated by the following calls
   glMatrixMode (GL_PROJECTION);
   glLoadIdentity ();
   gluOrtho2D (0.0, width, 0.0, height);
   DrawGLScene();
 end;
end.

