unit Ch05;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs, OpenGL, SPF,
  ExtCtrls, Math ;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  rtri: GLfloat;      // Angle For The Triangle
  rquad: GLfloat;     // Angle For The Quad
  f_Hdc : LongInt;

implementation

{$R *.DFM}

function calculateAngle(size,distance : double ):double ;
const PI= 3.1415926535;
var
  radtheta, degtheta : double;
begin
  // defined in math math unit
  radtheta := 2.0 * ArcTan2 (size/2.0, distance);
  degtheta := (180.0 * radtheta) / PI;
  calculateAngle := degtheta;
end;

procedure InitGL();	// All Setup For OpenGL Goes Here
begin
  glShadeModel(GL_SMOOTH);	       // Enables Smooth Color Shading
  glClearColor(1.0, 1.0, 1.0, 0.5);    // Black Background
  glEnable(GL_DEPTH_TEST);	       // Enables Depth Testing
  glDepthFunc(GL_LESS);		       // The Type Of Depth Test To Do
  glClearDepth(1.0);		       // Depth Buffer Setup
  //Realy Nice perspective calculations
  glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
end;

procedure DrawGLScene();    // Here's Where We Do All The Drawing
begin
  // Clear The Screen And The Depth Buffer
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();		      // Reset The View
  glTranslatef(-1.5,0.0,-6.0);
  glRotatef(rtri,0.0,1.0,0.0);        // Rotate The Triangle On The Y axis
  glBegin(GL_POLYGON);
    glColor3f(1.0,0.0,0.0);           // Set The Color
    glVertex3f( 0.0, 1.0, 0.0);
    glColor3f(1.0,1.0,0.0);           // Set The Color
    glVertex3f(-1.0,-1.0, 0.0);
    glColor3f(0.0,1.0,1.0);           // Set The Color
    glVertex3f( 1.0,-1.0, 0.0);
  glEnd();
   glLoadIdentity();
  glTranslatef(1.5,0.0,-6.0);
  glColor3f(0.5,0.5,1.0);             // Set The Color To Blue One Time Only
  glRotatef(rquad,1.0,0.0,0.0);       // Rotate The Quad On The X axis
  glBegin(GL_QUADS);
    glVertex3f(-1.0, 1.0, 0.0);   glVertex3f( 1.0, 1.0, 0.0);
    glVertex3f( 1.0,-1.0, 0.0);   glVertex3f(-1.0,-1.0, 0.0);
  glEnd();

  //glFlush();  {does not work with PFD_DOUBLEBUFFER}
   SwapBuffers(f_Hdc); { works with PFD_DOUBLEBUFFER }
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  f_Hdc := GetDC(handle);
  SetDCPixelFormat(f_Hdc,24,32);// Create a rendering context.
  InitGL;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  CleanUp(f_Hdc);// Clean up and terminate.
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  wglMakeCurrent(f_Hdc,hrc); //activate the RC
  DrawGLScene;    // Draw the scene.
end;

procedure TForm1.FormResize(Sender: TObject);
 var  degAngle, gldAspect : GLdouble;
begin
  wglMakeCurrent(f_Hdc,hrc);
  gldAspect := Width / Height;
  degAngle:= calculateAngle(Height,350);
  // Reset The Current Viewport And Perspective Transformation
  glViewport(0 , 0, Width, Height);
  glMatrixMode(GL_PROJECTION);       // Select The Projection Matrix
  glLoadIdentity();                  // Reset The Projection Matrix
  // Calculate The Aspect Ratio Of The Window
  gluPerspective(degAngle,gldAspect,0.1,100.0);
  glMatrixMode(GL_MODELVIEW);        // Select The Modelview Matrix
  glLoadIdentity();                  //Reset The Modelview Matrix

  InvalidateRect(Handle, nil, False);// DrawGLScene;  Draw the scene.
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  rtri := (rtri + 5.5)  ;   // Increase The Rotation Variable For The Triangle
  rquad := (rquad - 5.5) ;  // Decrease The Rotation Variable For The Quad

  Application.ProcessMessages;
  InvalidateRect(Handle, nil, False);//   DrawGLScene();
end;

end.
