unit Ch06;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, OpenGL, SPF, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormResize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  rtri: GLfloat;      // Angle For The Triangle
  rquad: GLfloat;     // Angle For The Quad
  f_Hdc : LongInt;

 implementation

{$R *.DFM}

procedure InitGL;	// All Setup For OpenGL Goes Here
begin
  glShadeModel(GL_SMOOTH);	       // Enables Smooth Color Shading
  glClearColor(1.0, 1.0, 1.0, 0.5);    // not Black Background!
  glClearDepth(1.0);		       // Depth Buffer Setup
  glEnable(GL_DEPTH_TEST);	       // Enables Depth Testing
  glDepthFunc(GL_LESS);		       // The Type Of Depth Test To Do
  //Realy Nice perspective calculations
  glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
end;

procedure DrawGLScene;    // Here's Where We Do All The Drawing

begin
  // Clear The Screen And The Depth Buffer
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();		      // Reset The View
  glTranslatef(-1.5,0.0,-6.0);
  glRotatef(rtri,0.0,1.0,0.0);        // Rotate The Triangle On The Y axis
  glBegin(GL_POLYGON);
    glColor3f(1.0,0.0,0.0);           // Red
    glVertex3f( 0.0, 1.0, 0.0);       // Top Of Triangle (Front)
    glColor3f(0.0,1.0,0.0);           // Green
    glVertex3f(-1.0,-1.0, 1.0);       // Left Of Triangle (Front)
    glColor3f(0.0,0.0,1.0);           // Blue
    glVertex3f( 1.0,-1.0, 1.0);       // Right Of Triangle (Front)

    glColor3f(1.0,0.0,0.0);           // Red
    glVertex3f( 0.0, 1.0, 0.0);       // Top Of Triangle (Right)
    glColor3f(0.0,0.0,1.0);           // Blue
    glVertex3f( 1.0,-1.0, 1.0);       // Left Of Triangle (Right)
    glColor3f(0.0,1.0,0.0);           // Green
    glVertex3f( 1.0,-1.0, -1.0);      // Right Of Triangle (Right)

    glColor3f(1.0,0.0,0.0);           // Red
    glVertex3f( 0.0, 1.0, 0.0);       // Top Of Triangle (Back)
    glColor3f(0.0,1.0,0.0);           // Green
    glVertex3f( 1.0,-1.0, -1.0);      // Left Of Triangle (Back)
    glColor3f(0.0,0.0,1.0);           // Blue
    glVertex3f(-1.0,-1.0, -1.0);      // Right Of Triangle (Back)

    glColor3f(1.0,0.0,0.0);           // Red
    glVertex3f( 0.0, 1.0, 0.0);       // Top Of Triangle (Left)
    glColor3f(0.0,0.0,1.0);           // Blue
    glVertex3f(-1.0,-1.0,-1.0);       // Left Of Triangle (Left)
    glColor3f(0.0,1.0,0.0);           // Green
    glVertex3f(-1.0,-1.0, 1.0);       // Right Of Triangle (Left)
  GlEnd();

  glLoadIdentity();
  glTranslatef(1.5,0.0,-6.0);
  glRotatef(rquad,1.0,1.0,1.0);       // Rotate The Quad On The X axis
//  glScalef(2.0,0.4,0.5);
  glBegin(GL_QUADS);                  // Start Drawing The Cube
    glColor3f(0.0,1.0,0.0);           // Set The Color To Blue
    glVertex3f( 1.0, 1.0,-1.0);       // Top Right Of The Quad (Top)
    glVertex3f(-1.0, 1.0,-1.0);       // Top Left Of The Quad (Top)
    glVertex3f(-1.0, 1.0, 1.0);       // Bottom Left Of The Quad (Top)
    glVertex3f( 1.0, 1.0, 1.0);       // Bottom Right Of The Quad (Top)

    glColor3f(1.0,0.5,0.0);           // Set The Color To Orange
    glVertex3f( 1.0,-1.0, 1.0);       // Top Right Of The Quad (Bottom)
    glVertex3f(-1.0,-1.0, 1.0);       // Top Left Of The Quad (Bottom)
    glVertex3f(-1.0,-1.0,-1.0);       // Bottom Left Of The Quad (Bottom)
    glVertex3f( 1.0,-1.0,-1.0);       // Bottom Right Of The Quad (Bottom)

    glColor3f(1.0,0.0,0.0);           // Set The Color To Red
    glVertex3f( 1.0, 1.0, 1.0);       // Top Right Of The Quad (Front)
    glVertex3f(-1.0, 1.0, 1.0);       // Top Left Of The Quad (Front)
    glVertex3f(-1.0,-1.0, 1.0);       // Bottom Left Of The Quad (Front)
    glVertex3f( 1.0,-1.0, 1.0);       // Bottom Right Of The Quad (Front)

    glColor3f(1.0,1.0,0.0);           // Set The Color To Yellow
    glVertex3f( 1.0,-1.0,-1.0);       // Top Right Of The Quad (Back)
    glVertex3f(-1.0,-1.0,-1.0);       // Top Left Of The Quad (Back)
    glVertex3f(-1.0, 1.0,-1.0);       // Bottom Left Of The Quad (Back)
    glVertex3f( 1.0, 1.0,-1.0);       // Bottom Right Of The Quad (Back)

    glColor3f(0.0,0.0,1.0);           // Set The Color To Blue
    glVertex3f(-1.0, 1.0, 1.0);       // Top Right Of The Quad (Left)
    glVertex3f(-1.0, 1.0,-1.0);       // Top Left Of The Quad (Left)
    glVertex3f(-1.0,-1.0,-1.0);       // Bottom Left Of The Quad (Left)
    glVertex3f(-1.0,-1.0, 1.0);       // Bottom Right Of The Quad (Left)

    glColor3f(1.0,0.0,1.0);           // Set The Color To Violet
    glVertex3f( 1.0, 1.0,-1.0);       // Top Right Of The Quad (Right)
    glVertex3f( 1.0, 1.0, 1.0);       // Top Left Of The Quad (Right)
    glVertex3f( 1.0,-1.0, 1.0);       // Bottom Left Of The Quad (Right)
    glVertex3f( 1.0,-1.0,-1.0);       // Bottom Right Of The Quad (Right)
  glEnd();                            // Done Drawing The Quad

  SwapBuffers(f_Hdc);
end;

procedure TForm1.FormResize(Sender: TObject);
var
  fWidth, fHeight: GLfloat;
begin
  wglMakeCurrent(f_Hdc,hrc); //activate the RC
// Prevent A Divide By Zero If The Window Is Too Small
// By Making The Height One
  if (Height=0) then
     Height:=1;
  // Reset The Current Viewport And Perspective Transformation
  glViewport(0, 0, Width, Height);
  glMatrixMode(GL_PROJECTION);       // Select The Projection Matrix
  glLoadIdentity();                  // Reset The Projection Matrix
  fWidth := width;
  fHeight := height;
  // Calculate The Aspect Ratio Of The Window
  gluPerspective(45.0,fWidth/fHeight,0.1,100.0);
  glMatrixMode(GL_MODELVIEW);        // Select The Modelview Matrix
  glLoadIdentity ;                    //Reset The Modelview Matrix
  InvalidateRect(Handle, nil, False);// DrawGLScene;  Draw the scene.
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  rtri := rtri + 5.2;    // Increase The Rotation Variable For The Triangle
  rquad := rquad - 5.15; // Decrease The Rotation Variable For The Quad

  Application.ProcessMessages;
  InvalidateRect(Handle, nil, False);//   DrawGLScene();
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 wglMakeCurrent(f_Hdc,hrc); //activate the RC
 DrawGLScene();
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 f_Hdc := GetDC(handle);
 SetDCPixelFormat(f_Hdc,16,16);// Create a rendering context.
 InitGL;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 CleanUp(f_Hdc);// Clean up and terminate.
end;

end.
