unit ch07_02;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    txtV1X: TEdit;
    txtV1Y: TEdit;
    txtV1Z: TEdit;
    txtV2X: TEdit;
    txtV2Y: TEdit;
    txtV2Z: TEdit;
    txtV3X: TEdit;
    txtV3Y: TEdit;
    txtV3Z: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    btnCalculate: TButton;
    Memo1: TMemo;
    procedure btnCalculateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
type
  ToutPut = array[0..2] of single;

implementation

{$R *.DFM}

procedure CalculateNormal(
              V1X,V1Y,V1Z,
              V2X,V2Y,V2Z,
              V3X,V3Y,V3Z : single;
              var outPut: ToutPut);
var
  vector1x,vector1y,vector1z : single;
  vector2x,vector2y,vector2z : single;
  outx,outy,outz : single;
  length : Real;
begin
	//Vector 1
	vector1x := V1X-V2X;
	vector1y := V1Y-V2Y;
	vector1z := V1Z-V2Z;
	//Vector 2
	vector2x := V2X-V3X;
	vector2y := V2Y-V3Y;
	vector2z := V2Z-V3Z;
	//Apply the Cross Product
	outx := vector1y*vector2z - vector1z * vector2y;
	outy := vector1z*vector2x - vector1x * vector2z;
	outz := vector1x*vector2y - vector1y * vector2x;
	//Normalize to a unit vector
	length := sqrt(outx*outx+outy*outy+outz*outz);
	if(length=0) then length := 1.0;
        outPut[0] := outx/length;
	outPut[1] := outy/length;
	outPut[2] := outz/length;
 end;

function generateOpenGL_Code(
              V1X,V1Y,V1Z,
              V2X,V2Y,V2Z,
              V3X,V3Y,V3Z : single ) : string;
var
  outPut :  ToutPut;
  strs : string;
begin
 strs := 'glBegin(GL_TRIANGLES);' +#13#10 ;

 CalculateNormal(
           V1X,V1Y,V1Z,
           V2X,V2Y,V2Z,
           V3X,V3Y,V3Z,
           outPut);

 strs := strs +
    'glNormal3f('+ floattostr(outPut[0]) + ',' + floattostr(outPut[1]) +','+
    floattostr(outPut[2]) + ');' +#13#10 ;

 strs := strs +
  '  glVertex3f('+ floattostr(V1X) +','+ floattostr(V1Y) +','+
   floattostr(V1Z) +');' +#13#10 ;

 strs :=strs +
  '  glVertex3f('+ floattostr(V2X) +','+ floattostr(V2Y) +','+
   floattostr(V2Z) +');' +#13#10 ;

 strs :=strs +
  '  glVertex3f('+ floattostr(V3X) +','+ floattostr(V3Y) +','+
   floattostr(V3Z) +');' +#13#10 ;

 generateOpenGL_Code := strs + 'glEnd();' +#13#10 ;
end;


procedure TForm1.btnCalculateClick(Sender: TObject);
begin
 Memo1.Text := 'Results : ' + #13#10 +
  generateOpenGL_Code(
    strtofloat(txtV1X.text),strtofloat(txtV1Y.text),strtofloat(txtV1Z.text),
    strtofloat(txtV2X.text),strtofloat(txtV2Y.text),strtofloat(txtV2Z.text),
    strtofloat(txtV3X.text),strtofloat(txtV3Y.text),strtofloat(txtV3Z.text)
  );

end;

end.
