unit Ch11;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, OpenGL,SPF;

type
  TForm1 = class(TForm)
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  f_Hdc : LongInt;

implementation
{$R *.DFM}

procedure gloWireSphere(radius : GLdouble; slices, stacks : GLint);
stdcall;external 'glo.dll';
procedure gloWireCone(base, height : GLdouble; slices, stacks : GLint);
stdcall;external 'glo.dll';
procedure gloWireCylinder(baseRadius, topRadius, height : GLdouble; slices,
 stacks : GLint); stdcall;external 'glo.dll';
procedure gloWireDisk(innerRadius, outerRadius : GLdouble;
 slices, stacks : GLint);stdcall;external 'glo.dll';
procedure gloWireCube(size : GLdouble); stdcall;external 'glo.dll';
procedure gloWireTorus(innerRadius, outerRadius : GLfloat;
 nsides, rings : GLint);stdcall;external 'glo.dll';
procedure gloWireTeapot(scale : GLdouble); stdcall;external 'glo.dll';
procedure gloWireDodecahedron(); stdcall;external 'glo.dll';
procedure gloWireOctahedron(); stdcall;external 'glo.dll';
procedure gloWireIsosahedron(); stdcall;external 'glo.dll';
procedure gloWireTetrahedron(); stdcall;external 'glo.dll';
procedure gloWireGear(inner_radius, outer_radius, width: double;
 teeth: integer; tooth_depth: double);stdcall;external 'glo.dll';
procedure gloWireSuperToroid(inner_radius, outer_radius,
 n1, n2 : Single; slices, stacks : Integer);stdcall;external 'glo.dll';
procedure gloWireSuperEllipsoid(width, n1, n2 : Single;
 slices, stacks : Integer);stdcall;external 'glo.dll';

procedure gloSolidSphere(radius : GLdouble; slices, stacks : GLint);
stdcall;external 'glo.dll';
procedure gloSolidCone(base, height : GLdouble; slices, stacks : GLint);
stdcall;external 'glo.dll';
procedure gloSolidCylinder(baseRadius, topRadius, height : GLdouble;
 slices, stacks : GLint);stdcall;external 'glo.dll';
procedure gloSolidDisk(innerRadius, outerRadius : GLdouble;
 slices, stacks : GLint);stdcall;external 'glo.dll';
procedure gloSolidCube(size : GLdouble); stdcall;external 'glo.dll';
procedure gloSolidTorus(innerRadius, outerRadius : GLfloat;
nsides, rings : GLint);stdcall;external 'glo.dll';
procedure gloSolidTeapot(scale : GLdouble); stdcall;external 'glo.dll';
procedure gloSolidDodecahedron(); stdcall;external 'glo.dll';
procedure gloSolidOctahedron(); stdcall;external 'glo.dll';
procedure gloSolidIsosahedron(); stdcall;external 'glo.dll';
procedure gloSolidTetrahedron(); stdcall;external 'glo.dll';
procedure gloSolidGear(inner_radius, outer_radius, width: double;
 teeth: integer; tooth_depth: double);stdcall;external 'glo.dll';
procedure gloSolidSuperToroid(inner_radius, outer_radius,
 n1, n2 : Single; slices, stacks : Integer);stdcall;external 'glo.dll';
procedure gloSolidSuperEllipsoid(width, n1, n2 : Single;
 slices, stacks : Integer);stdcall;external 'glo.dll';

var
   ambient : array[0..3] of  GLfloat =( 0, 0, 0, 1 );
   diffuse : array[0..3] of  GLfloat =( 1, 1, 1, 1 );
   specular : array[0..3] of  GLfloat =( 1, 1, 1, 1 );
   position : array[0..3] of  GLfloat =( 0, 3, 3, 0 );
   lmodel_ambient : array[0..3] of  GLfloat =( 0.2, 0.2, 0.2, 1 );
   local_view : array[0..0] of  GLfloat =( 0 );

   Obj1  : GLuint;                 // Storage For The Display List
   Obj2  : GLuint;                 // Storage For The Second Display List
   Obj3  : GLuint;   Obj4  : GLuint;
   Obj5  : GLuint;   Obj6  : GLuint;
   Obj7  : GLuint;   Obj8  : GLuint;
   Obj9  : GLuint;   Obj10  : GLuint;
   Obj11  : GLuint;   Obj12  : GLuint;
   Obj13  : GLuint;   Obj14  : GLuint;
   Obj15  : GLuint;   Obj16  : GLuint;
   Obj17  : GLuint;   Obj18  : GLuint;
   Obj19  : GLuint;   Obj20  : GLuint;
   Obj21  : GLuint;   Obj22  : GLuint;
   Obj23  : GLuint;   Obj24  : GLuint;

Procedure initGL();

begin
   glClearColor(1,1,1,0);
   glLightfv (GL_LIGHT0, GL_AMBIENT, @ambient);
   glLightfv (GL_LIGHT0, GL_DIFFUSE, @diffuse);
   glLightfv (GL_LIGHT0, GL_POSITION, @position);
   glLightModelfv (GL_LIGHT_MODEL_Ambient, @lmodel_ambient);
   glLightModelfv (GL_LIGHT_MODEL_LOCAL_VIEWER, @local_view);

   glEnable (GL_LIGHTING);
   glEnable (GL_LIGHT0);
   glEnable (GL_DEPTH_TEST);
//  be efficient--make Object display list
   Obj1 := glGenLists(20);
   glNewList (Obj1, GL_COMPILE);
     gloSolidTetrahedron();
   glEndList;

   Obj2 := Obj1 + 1 ;
   glNewList (Obj2, GL_COMPILE);
     gloSolidSphere(0.7,10,10);
   glEndList;

   Obj3 := Obj2 + 1 ;
   glNewList (Obj3, GL_COMPILE);
     gloSolidCone(0.5,2.70,10,10);
   glEndList;

   Obj4 := Obj3 + 1 ;
   glNewList (Obj4, GL_COMPILE);
     gloSolidCylinder(0.4,0.7,4.7,10,10);
   glEndList;

   Obj5 := Obj4 + 1 ;
   glNewList (Obj5, GL_COMPILE);
     gloSolidDisk(0.3,0.7,10,10);
   glEndList;

   Obj6 := Obj5 + 1 ;
   glNewList (Obj6, GL_COMPILE);
     gloSolidCube(1);
   glEndList;

   Obj7 := Obj6 + 1 ;
   glNewList (Obj7, GL_COMPILE);
     gloSolidTorus(0.1,0.4,10,10);
   glEndList;

   Obj8 := Obj7 + 1 ;
   glNewList (Obj8, GL_COMPILE);
     gloSolidTeapot(1);
   glEndList;

   Obj9 := Obj8 + 1 ;
   glNewList (Obj9, GL_COMPILE);
     gloSolidDodecahedron();
   glEndList;

   Obj10 := Obj9 + 1 ;
   glNewList (Obj10, GL_COMPILE);
     gloSolidOctahedron();
   glEndList;

   Obj11 := Obj10 + 1 ;
   glNewList (Obj11, GL_COMPILE);
     gloSolidIsosahedron();
   glEndList;

   Obj12 := Obj11 + 1 ;
   glNewList (Obj12, GL_COMPILE);
     gloSolidTetrahedron();
   glEndList;

   Obj13 := Obj12 + 1 ;
   glNewList (Obj13, GL_COMPILE);
     gloSolidGear(0.2,0.7,0.3,4,1);
   glEndList;

   Obj14 := Obj13 + 1 ;
   glNewList (Obj14, GL_COMPILE);
     gloSolidSuperToroid(0.3,0.7,0.5,0.5,10,10);
   glEndList;

   Obj15 := Obj14 + 1 ;
   glNewList (Obj15, GL_COMPILE);
     gloSolidSuperEllipsoid(0.5,0.4,0.4,10,10);
   glEndList;

   Obj16 := Obj15 + 1 ;
   glNewList (Obj16, GL_COMPILE);
     gloWireSphere(1.0,10,10);
   glEndList;

   Obj17 := Obj16 + 1 ;
   glNewList (Obj17, GL_COMPILE);
     gloWireCone(0.5,3.8,10,10);
   glEndList;

   Obj18 := Obj17 + 1 ;
   glNewList (Obj18, GL_COMPILE);
     gloWireCylinder(0.5,0.5,1.8,10,10);
   glEndList;

   Obj19 := Obj18 + 1 ;
   glNewList (Obj19, GL_COMPILE);
     gloWireDisk(0.3,0.8,10,10);
   glEndList;

   Obj20 := Obj19 + 1 ;
   glNewList (Obj20, GL_COMPILE);
     gloWireCube(1.1);
   glEndList;

   Obj21 := Obj20 + 1 ;
   glNewList (Obj21, GL_COMPILE);
     gloWireTorus(0.4,0.8,10,10);
   glEndList;

   Obj22 := Obj21 + 1 ;
   glNewList (Obj22, GL_COMPILE);
     gloWireTeapot(1);
   glEndList;

   Obj23 := Obj22 + 1 ;
   glNewList (Obj23, GL_COMPILE);
     gloWireDodecahedron();
   glEndList;

   Obj24 := Obj23 + 1 ;
   glNewList (Obj24, GL_COMPILE);
     gloWireOctahedron();
   glEndList;


End;

//  Move object into position.  Use 3rd through 12th
//  parameters to specify the material property.  Draw an Object.
procedure renderObject(x, y,
                       ambr, ambg, ambb,
                       difr, difg, difb ,
                       specr, specg, specb,
                       shine : GLfloat;
                       ObjIndex : GLuint);
var
    mat : array[0..3] of  GLfloat ;
begin
   glPushMatrix;
   glRotatef(20,1,1,0);
   glTranslatef (x, y, 0);
   mat[0] := ambr; mat[1] := ambg; mat[2] := ambb; mat[3] := 1;
   glMaterialfv (GL_FRONT, GL_AMBIENT, @mat);
   mat[0] := difr; mat[1] := difg; mat[2] := difb;
   glMaterialfv (GL_FRONT, GL_DIFFUSE, @mat);
   mat[0] := specr; mat[1] := specg; mat[2] := specb;
   glMaterialfv (GL_FRONT, GL_SPECULAR, @mat);
   glMaterialf (GL_FRONT, GL_SHININESS, shine * 128);
   glCallList (ObjIndex);
   glPopMatrix;
End;

procedure DrawGLScene();
begin
   glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT);

   renderObject (2, 17, 0.0215, 0.1745, 0.0215,
      0.07568, 0.61424, 0.07568, 0.633, 0.727811, 0.633, 0.6,Obj1);
   renderObject (2, 14, 0.135, 0.2225, 0.1575,
      0.54, 0.89, 0.63, 0.316228, 0.316228, 0.316228, 0.1,Obj2);
   renderObject (2, 11, 0.05375, 0.05, 0.06625,
      0.18275, 0.17, 0.22525, 0.332741, 0.328634, 0.346435, 0.3,Obj3);
   renderObject (2, 8, 0.25, 0.20725, 0.20725,
      1, 0.829, 0.829, 0.296648, 0.296648, 0.296648, 0.088,Obj4);
   renderObject (2, 5, 0.1745, 0.01175, 0.01175,
      0.61424, 0.04136, 0.04136, 0.727811, 0.626959, 0.626959, 0.6,Obj5);
   renderObject (2, 2, 0.1, 0.18725, 0.1745,
      0.396, 0.74151, 0.69102, 0.297254, 0.30829, 0.306678, 0.1,Obj6);
   renderObject (6, 17, 0.329412, 0.223529, 0.027451,
      0.780392, 0.568627, 0.113725, 0.992157, 0.941176, 0.807843,
      0.21794872,Obj7);
   renderObject (6, 14, 0.2125, 0.1275, 0.054,
      0.714, 0.4284, 0.18144, 0.393548, 0.271906, 0.166721, 0.2,Obj8);
   renderObject (6, 11, 0.25, 0.25, 0.25,
      0.4, 0.4, 0.4, 0.774597, 0.774597, 0.774597, 0.6,Obj9);
   renderObject (6, 8, 0.19125, 0.0735, 0.0225,
       0.7038, 0.27048, 0.0828, 0.256777, 0.137622, 0.086014, 0.1,Obj10);
   renderObject (6, 5, 0.24725, 0.1995, 0.0745,
      0.75164, 0.60648, 0.22648, 0.628281, 0.555802, 0.366065, 0.4,Obj11);
   renderObject (6, 2, 0.19225, 0.19225, 0.19225,
       0.50754, 0.50754, 0.50754, 0.508273, 0.508273, 0.508273, 0.4,Obj12);
   renderObject (10, 17, 0, 0, 0, 0.01, 0.01, 0.01,
      0.5, 0.5, 0.5, 0.25 ,Obj13);
   renderObject (10, 14, 0, 0.1, 0.06, 0, 0.50980392, 0.50980392,
      0.50196078, 0.50196078, 0.50196078, 0.25,Obj14);
   renderObject (10, 11, 0, 0, 0,
      0.1, 0.35, 0.1, 0.45, 0.55, 0.45, 0.25,Obj15);
   renderObject (10, 8, 0, 0, 0, 0.5, 0, 0,
      0.7, 0.6, 0.6, 0.25,Obj16);
   renderObject (10, 5, 0, 0, 0, 0.55, 0.55, 0.55,
      0.7, 0.7, 0.7, 0.25,Obj17);
   renderObject (10, 2, 0, 0, 0, 0.5, 0.5, 0,
      0.6, 0.6, 0.5, 0.25,Obj18);
   renderObject (14, 17, 0.02, 0.02, 0.02, 0.01, 0.01, 0.01,
      0.4, 0.4, 0.4, 0.078125,Obj19);
   renderObject (14, 14, 0, 0.05, 0.05, 0.4, 0.5, 0.5,
      0.04, 0.7, 0.7, 0.078125,Obj20);
   renderObject (14, 11, 0, 0.05, 0, 0.4, 0.5, 0.4,
      0.04, 0.7, 0.04, 0.078125,Obj21);
   renderObject (14, 8, 0.05, 0, 0, 0.5, 0.4, 0.4,
      0.7, 0.04, 0.04, 0.078125,Obj22);
   renderObject (14, 5, 0.05, 0.05, 0.05, 0.5, 0.5, 0.5,
      0.7, 0.7, 0.7, 0.078125,Obj23);
   renderObject (14, 2, 0.05, 0.05, 0, 0.5, 0.5, 0.4,
      0.7, 0.7, 0.04, 0.078125,Obj24);

   SwapBuffers(f_Hdc);

End;


procedure TForm1.FormResize(Sender: TObject);
begin
   wglMakeCurrent(f_Hdc,hrc); //activate the RC
   glViewport (0, 0, width, height);
   glMatrixMode (GL_PROJECTION);
   glLoadIdentity;
   If (width <= height) Then
      glOrtho (0, 16, 0, 16 * height / width, -10, 10)
   Else
      glOrtho (0, 16 * width / height, 0, 16, -10, 10);

   glMatrixMode (GL_MODELVIEW);
  InvalidateRect(Handle, nil, False);// DrawGLScene;  Draw the scene.
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 f_Hdc := GetDC(handle);
 SetDCPixelFormat(f_Hdc,16,16);// Create a rendering context.
 InitGL();
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 CleanUp(f_Hdc);// Clean up and terminate.
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 DrawGLScene();
 wglMakeCurrent(f_Hdc,hrc); //activate the RC
end;

end.
