unit Ch17;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms,Dialogs , SPF , OpenGL , ExtCtrls ;
type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
var
  Form1: TForm1;

  f_Hdc : LongInt;

implementation
{$R *.dfm}

const
 EARTH =101 ;// This is the object ID for the EARTH
 SUN  =100 ; // This is the object ID for the SUN
 PLUTO =102 ;// This is the object ID for PLUTO
var
 SunRotation : single   = 90;// This holds our sun's current rotation
 EarthRotation :single = 90; // This holds our earth's current rotation
 PlutoRotation : single = 90;// This holds pluto's current rotation
 pObj  : GLUquadricObj;	// Storage For Our Quadratic Objects

    ambient : array[0..3] of GLfloat=( 0, 0, 0, 1 );
    diffuse : array[0..3] of GLfloat=( 1, 1, 1, 1 );
    specular : array[0..3] of GLfloat=( 1, 1, 1, 1 );
    position :array[0..3] of GLfloat=( 0, 3, 2, 0 );
    lmodel_ambient :array[0..3] of GLfloat=( 0.4, 0.4, 0.4, 1 );
    local_view : array[0..0] of GLfloat=(0);

    no_mat :array[0..3] of GLfloat=( 0, 0, 0, 1 );
    mat_diffuse  :array[0..3] of GLfloat=(0.1, 0.5, 0.4, 1);
    no_shininess : array[0..0] of GLfloat=(0);

    mat_ambient_color1 :array[0..3] of GLfloat=(0.2, 0.8, 0.2, 1);
    mat_emission1 :array[0..3] of GLfloat=( 0.3, 0.2, 0.2, 0 );

    mat_ambient_color :array[0..3] of GLfloat=(0.1, 0.4, 0.1, 1);
    mat_emission :array[0..3] of GLfloat=( 0.5, 0.1, 0.1, 0 );

/////////////////////////// INITIALIZE GL \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
///
///	This function handles all the initialization for OpenGL.
///
/////////////////////////// INITIALIZE GL \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*

procedure InitGL();
begin

  glClearColor (0, 0.1, 0.1, 0);
  glEnable(GL_DEPTH_TEST);  	// Enable Depth Testing

   glLightfv (GL_LIGHT0, GL_AMBIENT, @ambient);
   glLightfv (GL_LIGHT0, GL_DIFFUSE, @diffuse);
   glLightfv (GL_LIGHT0, GL_POSITION, @position);
   glLightModelfv (GL_LIGHT_MODEL_Ambient, @lmodel_ambient);
   glLightModelfv (GL_LIGHT_MODEL_LOCAL_VIEWER, @local_view);

   glEnable (GL_LIGHTING);
   glEnable (GL_LIGHT0);
end;

procedure RenderScene();
begin
    // Clear The Screen And The Depth Buffer
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();	 // Reset The matrix
    gluLookAt(0, 3, 6,     0, 0, 0,     0, 1, 0);
    // This clears the name stack so we always start with 0 names.
    glInitNames();
    // This next line is important.  If you don't push on at least ONE name,
    // The selection won't work.  Instead of glLoadName()/glEnd() you can use
    // glPushName(TheID) and glPopName();  Then you don't need to glPushName(0);
    glPushName(0);    // This starts off the first object in the stack
    // Get a new Quadric off the stack
    pObj := gluNewQuadric();
    glLoadName(SUN); 	// Push on our SUN label (IMPORTANT)

    glBegin(GL_LINES);
    glEnd();

    // Here we push on a new matrix so we don't affect any other quadrics.
    glPushMatrix();		// Push on a new matrix scope
    	glTranslatef(0, 0, 0);	// Translate this sphere to the left
        // Rotate the sphere around the Y axis to make it spin
    	glRotatef(SunRotation, 0, 1.0, 0);

        glMaterialfv (GL_FRONT, GL_AMBIENT, @no_mat);
        glMaterialfv (GL_FRONT, GL_DIFFUSE, @mat_diffuse);
        glMaterialfv (GL_FRONT, GL_SPECULAR, @no_mat);
        glMaterialfv (GL_FRONT, GL_SHININESS, @no_shininess);
        glMaterialfv (GL_FRONT, GL_EMISSION, @no_mat);

    	gluSphere(pObj, 0.5, 20, 20); // Draw the sunwith a radius of 0.5
    glPopMatrix(); 	// End the current scope of this matrix
   glEnd(); // Stop assigning polygons to the SUN label (IMPORTANT)

   glLoadName(EARTH);	// Push on our EARTH label (IMPORTANT)

   glBegin(GL_LINES);
   glEnd();

   glPushMatrix();	 // Push on a new matrix scope
     // Rotate the sphere around the origin (the sun)
     glRotatef(EarthRotation / 3, 0, 1.0, 0);
     glTranslatef(-2, 0, 0);	// Translate this sphere to the left
     glRotatef(EarthRotation, 0, 1.0, 0); // Rotate the sphere to make it spin

     glMaterialfv (GL_FRONT, GL_AMBIENT, @mat_ambient_color);
     glMaterialfv (GL_FRONT, GL_DIFFUSE, @mat_diffuse);
     glMaterialfv (GL_FRONT, GL_SPECULAR, @no_mat);
     glMaterialfv (GL_FRONT, GL_SHININESS, @no_shininess);
     glMaterialfv (GL_FRONT, GL_EMISSION, @mat_emission);

     // Draw the sphere with a radius of 0.2 so it's smaller than the sun
     gluSphere(pObj, 0.2, 20, 20);
   glPopMatrix(); // End the current scope of this matrix
    glEnd();	// Stop assigning polygons to the EARTH label (IMPORTANT)

    glLoadName(PLUTO); 	// Push on our PLUTO label (IMPORTANT)

    glBegin(GL_LINES);
    glEnd();

    glPushMatrix(); // Push on a new matrix scope
       // Rotate the sphere around the sun
       glRotatef(PlutoRotation / 2, 0, 1.0, 0);
       // Translate this sphere farther away from the sun than the earth
       glTranslatef(3, 0, 0);
       // Rotate the sphere around itself to produce the spin
       glRotatef(PlutoRotation, 0, 1.0, 0);

     glMaterialfv (GL_FRONT, GL_AMBIENT, @mat_ambient_color1);
     glMaterialfv (GL_FRONT, GL_DIFFUSE, @mat_diffuse);
     glMaterialfv (GL_FRONT, GL_SPECULAR, @no_mat);
     glMaterialfv (GL_FRONT, GL_SHININESS, @no_shininess);
     glMaterialfv (GL_FRONT, GL_EMISSION, @mat_emission1);

       // Draw the sphere with a radius of 0.1 (smallest planet)
       gluSphere(pObj, 0.1, 20, 20);
       glPopMatrix();  	// End the current scope of this matrix
     glEnd(); // Stop assigning polygons to our PLUTO label (IMPORTANT)

     SwapBuffers(f_Hdc);   // Swap the backbuffers to the foreground
     gluDeleteQuadric(pObj);	// Free the Quadric
    // Below we increase the rotations for each sphere.
    SunRotation   :=SunRotation+ 2.2;// Rotate the sun slowly
    EarthRotation :=SunRotation+ 2.5;// Increase the rotation for the each
    PlutoRotation :=SunRotation+ 2.6;// Make pluto go the fastest
end;

///////////////////////////////// PROCESS SELECTION \\\\\\\\\\\
//
// This takes the cursor's x and y position
// and returns the closet object
//
///////////////////////////////// PROCESS SELECTION \\\\\\\\\\\
function RetrieveObjectID( x, y : LongInt;
                           height,width: integer ): LongInt;
var
  // This will hold the amount of objects clicked
  objectsFound , i : LongInt;
  // We need an array to hold our view port coordinates
  viewportCoords : array[0..3] of  Gluint;
 // This will hold the ID's of the objects we click on.
 // We make it an arbitrary number of 32
  selectBuffer : array[0..31] of Gluint;
  lowestDepth , selectedObject : Gluint;
begin
   // glSelectBuffer is what we register our selection buffer with.
   // Setup our selection buffer to accept object ID's

   glSelectBuffer(32, @selectBuffer);
   // This function returns information about many things in OpenGL.
   //  We pass in GL_VIEWPORT
   // to get the view port coordinates.
   glGetIntegerv(GL_VIEWPORT, @viewportCoords);

   // Now we want to get out of our GL_MODELVIEW matrix and
   // start effecting our GL_PROJECTION matrix.
   // This allows us to check our X and Y coords against 3D space.
   glMatrixMode(GL_PROJECTION);
   // We push on a new matrix so we don't effect our 3D projection
   glPushMatrix();
        // Allows us to render the objects, but not change the frame buffer
	glRenderMode(GL_SELECT);
	glLoadIdentity(); // Reset our projection matrix
	// gluPickMatrix allows us to create a projection
        // matrix that is around our cursor.
        // NOTE : y has -27 to account to caption bar
        gluPickMatrix(x, form1.Height - y-27, 2, 2, @viewportCoords); //or
//	gluPickMatrix(x, viewportCoords[3] - y, 2, 2, @viewportCoords);
	// Next, we just call our normal gluPerspective() function,
        //exactly as we did on startup.
	// This is to multiply the perspective matrix by the
        //pick matrix we created up above.

       gluPerspective(45.0, viewportCoords[2]/viewportCoords[3], 1.0, 100.0);

	glMatrixMode(GL_MODELVIEW); // Go back into our model view matrix
        // Now we render into our selective mode to pinpoint clicked objects
	RenderScene();
        // If we return to our normal render mode from select mode,
        //glRenderMode returns
	// the number of objects that were found in our specified
        // region (specified in gluPickMatrix())
        objectsFound := glRenderMode(GL_RENDER);

        // Put our projection matrix back to normal.
	glMatrixMode(GL_PROJECTION);
    glPopMatrix();	// Stop effecting our projection matrix
     glMatrixMode(GL_MODELVIEW);
    //objectsFound should be at least 1 if we found an object.

	if (objectsFound > 0)     then
        begin
	// If we found more than one object, we need to check the depth values
	// of all the objects found.  The object with the LEAST depth value is
	// the closest object that we clicked on.
	lowestDepth := selectBuffer[1];
	selectedObject := selectBuffer[3];
	// Go through all of the objects found, but start at the second one
	  for  i := 1  to objectsFound-1 do
             begin
             // Check if the current objects depth is lower
             //than the current lowest
             // Notice we times i by 4 (4 values for each object)
             // and add 1 for the depth.
   		if(selectBuffer[(i * 4) + 1] < lowestDepth) then
		  begin
		     // Set the current lowest depth
		     lowestDepth := selectBuffer[(i * 4) + 1];
		     // Set the current object ID
		     selectedObject := selectBuffer[(i * 4) + 3];
		  end;
	     end;
		// Return the selected object
		RetrieveObjectID := selectedObject;
                exit;
	end;
	// We didn't click on any objects so return 0
	RetrieveObjectID := 0;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
   wglMakeCurrent(f_Hdc,hrc); //activate the RC
   if (height=0) then   // Prevent A Divide By Zero error
   	height:=1;     // Make the Height Equal One
   glViewport(0,0,width,height); // Make our viewport the whole window
   glMatrixMode(GL_PROJECTION);// Select The Projection Matrix
   glLoadIdentity();	   // Reset The Projection Matrix
   // Calculate The Aspect Ratio Of The Window
   gluPerspective(45.0,width/height,0.1,450.0);
   glMatrixMode(GL_MODELVIEW);  // Select The Modelview Matrix
   glLoadIdentity();	     // Reset The Modelview Matrix
   InvalidateRect(Handle, nil, False);// DrawGLScene;  Draw the scene.
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 CleanUp(f_Hdc);// Clean up and terminate.
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 f_Hdc := GetDC(handle);
 SetDCPixelFormat(f_Hdc,16,16);// Create a rendering context.
 InitGL();
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 wglMakeCurrent(f_Hdc,hrc); //activate the RC
 RenderScene;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Application.ProcessMessages; //DoEvents
  InvalidateRect(Handle, nil, False);//   DrawScene();
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var
    objectID : Integer;
begin
  // Here we pass in the cursors X and Y coordinates to
  //test for an object under the mouse.
    objectID := RetrieveObjectID(x,y,height,width);
  // Now we just do a switch on our object ID's to see if we hit one.
  // Check the objectID passed back
    form1.Resize;
  if objectID= SUN then
               	MessageBox(handle, 'The Sun!', 'Click', MB_OK);
  if objectID= EARTH then 	// We hit the Earth!
		MessageBox(handle, 'The Earth!', 'Click', MB_OK);
  if objectID= PLUTO then    	// We hit Pluto!
		MessageBox(handle, 'Pluto!', 'Click', MB_OK);


end;

end.
