unit ch21_01;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms,  Dialogs , OpenGL , SPF;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

procedure gluNextContour(tess: GLUtesselator; atype: GLenum);
 stdcall;external glu32;

 const
  // Contours types -- obsolete!
  GLU_CW          = 100120;
  GLU_CCW         = 100121;
  GLU_INTERIOR    = 100122;
  GLU_EXTERIOR    = 100123;
  GLU_UNKNOWN     = 100124;

{$R *.dfm}

var
  currentWinding : GLdouble = GLU_TESS_WINDING_ODD;
  currentShape : integer = 0;
  tobj : GLUtesselator; // the tessellation object
  list : GLuint;
  f_Hdc : longInt;

 rects : array[0..11] of array[0..2] of GLdouble =
 ((50.0, 50.0, 0.0), (300.0, 50.0, 0.0),
  (300.0, 300.0, 0.0), (50.0, 300.0, 0.0),
  (100.0, 100.0, 0.0), (250.0, 100.0, 0.0),
  (250.0, 250.0, 0.0), (100.0, 250.0, 0.0),
  (150.0, 150.0, 0.0), (200.0, 150.0, 0.0),
  (200.0, 200.0, 0.0), (150.0, 200.0, 0.0));

 spiral : array[0..15] of array[0..2] of GLdouble =
((400.0, 250.0, 0.0), (400.0, 50.0, 0.0),
 (50.0, 50.0, 0.0), (50.0, 400.0, 0.0),
 (350.0, 400.0, 0.0), (350.0, 100.0, 0.0),
 (100.0, 100.0, 0.0), (100.0, 350.0, 0.0),
 (300.0, 350.0, 0.0), (300.0, 150.0, 0.0),
 (150.0, 150.0, 0.0), (150.0, 300.0, 0.0),
 (250.0, 300.0, 0.0), (250.0, 200.0, 0.0),
 (200.0, 200.0, 0.0), (200.0, 250.0, 0.0));

 quad1 : array[0..3] of array[0..2] of GLdouble =
((50.0, 150.0, 0.0), (350.0, 150.0, 0.0),
 (350.0, 200.0, 0.0), (50.0, 200.0, 0.0));

quad2 : array[0..3] of array[0..2] of GLdouble =
((100.0, 100.0, 0.0), (300.0, 100.0, 0.0),
 (300.0, 350.0, 0.0), (100.0, 350.0, 0.0));

tri : array[0..2] of array[0..2] of GLdouble =
((200.0, 50.0, 0.0), (250.0, 300.0, 0.0),
 (150.0, 300.0, 0.0));

type
   my_arr = array of GLdouble;

{
 * This program demonstrates the winding rule polygon
 * tessellation property. Four tessellated objects are drawn,
 * each with very different contours. When a key is pressed,
 * the objects are drawn with a different winding rule.
}

 //Note: without the stdcall directive, Windows will not be able to access
 // the callback function.
 //This ensures parameters are passed in the correct order.
procedure errorCallback( errorCode :GLenum); stdcall;
var
  estring : Pchar;
begin

   Case errorCode of

      GLU_TESS_MISSING_BEGIN_POLYGON :
             MessageBox(0,'GLU_TESS_MISSING_BEGIN_POLYGON',
                        'error..',MB_OK);

      GLU_TESS_MISSING_END_POLYGON :
             MessageBox(0,'GLU_TESS_MISSING_END_POLYGON',
                        'error..',MB_OK);

      GLU_TESS_MISSING_BEGIN_CONTOUR :
             MessageBox(0,'GLU_TESS_MISSING_BEGIN_CONTOUR',
                        'error..',MB_OK);

      GLU_TESS_MISSING_END_CONTOUR :
             MessageBox(0,'GLU_TESS_MISSING_END_CONTOUR',
                        'error..',MB_OK);

      GLU_TESS_COORD_TOO_LARGE :
             MessageBox(0,'GLU_TESS_COORD_TOO_LARGE',
                         'error..',MB_OK);

      GLU_TESS_NEED_COMBINE_CALLBACK :
             MessageBox(0,'GLU_TESS_NEED_COMBINE_CALLBACK',
                        'error..',MB_OK);
    End ;

  estring := gluErrorString(errorCode);
  MessageBox(0,estring,'error..',MB_OK);

end;

procedure beginCallback(which : GLenum );stdcall;
begin
  glBegin(which);
end;

procedure endCallback();stdcall;
begin
  glEnd();
end;

procedure tessVertex(data: Pointer); stdcall;
begin

  { This callback is invoked for each vertex in the triangulation. The data
    parameter is a pointer we passed to gluTessVertex(). (see below)
    In this case, it points to a double-precision 3D vector. }
  glVertex3dv(data);
end;

{* combineCallback is used to create a new vertex when edges
* intersect. coordinate location is trivial to calculate,
* but weight[4] may be used to average color, normal, or texture
* coordinate data.}

{ void CALLBACK combineCallback(GLdouble coords[3],
   GLdouble *data[4],
   GLfloat weight[4], GLdouble **dataOut )
{
 GLdouble *vertex;
 vertex = (GLdouble *) malloc(3 * sizeof(GLdouble));
 vertex[0] = coords[0];
 vertex[1] = coords[1];
 vertex[2] = coords[2];
 *dataOut = vertex;
}


// this procedure has a little BUG!!
procedure combineCallback(
               coords : my_arr;
               var vdata   : pointer;
               weight  : pointer;
               var dataOut : my_arr); stdcall;
var
  vertex : my_arr;
begin
  setLength(vertex,2);

  vertex[0] := coords[0];
  vertex[1] := coords[1];
  vertex[2] := coords[2];

  dataOut := vertex;
end;

{ Make four display lists,
 each with a different tessellated object.}
procedure makeNewLists ();
var
   i : integer;
begin

  gluTessProperty(tobj, GLU_TESS_WINDING_RULE,
                  currentWinding );

  glNewList(list, GL_COMPILE);
    gluTessBeginPolygon(tobj);
      gluTessBeginContour(tobj);
        for i := 0 to 3 do
          gluTessVertex(tobj, @rects[i], @rects[i]);
      gluTessEndContour(tobj);

      gluTessBeginContour(tobj);
        for i := 4 to 7 do
          gluTessVertex(tobj, @rects[i], @rects[i]);
      gluTessEndContour(tobj);

      gluTessBeginContour(tobj);
        for i := 8 to  11 do
          gluTessVertex(tobj, @rects[i], @rects[i]);
      gluTessEndContour(tobj);
    gluTessEndPolygon(tobj);
  glEndList();

  glNewList(list+1, GL_COMPILE);
      gluTessBeginPolygon(tobj);
        gluTessBeginContour(tobj);
           for i := 0 to 3 do
             gluTessVertex(tobj, @rects[i], @rects[i]);
        gluTessEndContour(tobj);

        gluTessBeginContour(tobj);
           for i := 7 downto 4 do
             gluTessVertex(tobj, @rects[i], @rects[i]);
        gluTessEndContour(tobj);

        gluTessBeginContour(tobj);
           for i := 11 downto 8 do
               gluTessVertex(tobj, @rects[i], @rects[i]);
        gluTessEndContour(tobj);
      gluTessEndPolygon(tobj);
  glEndList();

  glNewList(list+2, GL_COMPILE);
      gluTessBeginPolygon(tobj);
         gluTessBeginContour(tobj);
            for i := 0 to 15 do
              gluTessVertex(tobj, @spiral[i], @spiral[i]);
         gluTessEndContour(tobj);
      gluTessEndPolygon(tobj);
  glEndList();

  glNewList(list+3, GL_COMPILE);
      gluTessBeginPolygon(tobj);
         gluTessBeginContour(tobj);
            for i := 0 to 3 do
              gluTessVertex(tobj, @quad1[i], @quad1[i]);
         gluTessEndContour(tobj);

         gluTessBeginContour(tobj);
             for i := 0 to 3 do
               gluTessVertex(tobj, @quad2[i], @quad2[i]);
         gluTessEndContour(tobj);

         gluTessBeginContour(tobj);
            for i := 0 to 2 do
              gluTessVertex(tobj, @tri[i], @tri[i]);
         gluTessEndContour(tobj);
      gluTessEndPolygon(tobj);
  glEndList();

end;

procedure display ();
begin

  glClear(GL_COLOR_BUFFER_BIT);
  glColor3f(1.0, 1.0, 1.0);

  glPushMatrix();
    glCallList(list);
    glTranslatef(0.0, 500.0, 0.0);
    glCallList(list+1);
    glTranslatef(500.0, -500.0, 0.0);
    glCallList(list+2);
    glTranslatef(0.0, 500.0, 0.0);
    glCallList(list+3);
  glPopMatrix();

  SwapBuffers(f_Hdc);
end;

procedure initGL();
begin

  glClearColor(0.0, 0.0, 0.0, 0.0);
  glShadeModel(GL_FLAT);

  tobj := gluNewTess();


  gluTessCallback(tobj, GLU_TESS_BEGIN, @beginCallback);
  gluTessCallback(tobj, GLU_TESS_END, @endCallback);
  gluTessCallback(tobj, GLU_TESS_VERTEX, @tessVertex);
  gluTessCallback(tobj, GLU_TESS_COMBINE, @combineCallback);
//  gluTessCallback(tobj, GLU_TESS_ERROR,@errorCallback);

  list := glGenLists(4);

  makeNewLists();

end;

procedure reshape( w, h : integer);
begin
  glViewport(0, 0, w, h);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   if (w <= h) then
     gluOrtho2D(0.0, 1000.0, 0.0, 1000.0 * h/w)
   else
     gluOrtho2D(0.0, 1000.0 * w/h, 0.0, 1000.0);

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
end;

procedure keyboard();
begin

 if (currentWinding = GLU_TESS_WINDING_ODD) then
  begin
       currentWinding := GLU_TESS_WINDING_NONZERO;
       form1.Caption :=  'GLU_TESS_WINDING_NONZERO';
   end;

 if (currentWinding = GLU_TESS_WINDING_NONZERO) then
  begin
      currentWinding := GLU_TESS_WINDING_POSITIVE;
      form1.Caption :=  'GLU_TESS_WINDING_POSITIVE';
  end;

 if (currentWinding = GLU_TESS_WINDING_POSITIVE) then
  begin
     currentWinding := GLU_TESS_WINDING_NEGATIVE;
     form1.Caption :=  'GLU_TESS_WINDING_NEGATIVE';
  end;


 if (currentWinding = GLU_TESS_WINDING_NEGATIVE) then
  begin
     currentWinding := GLU_TESS_WINDING_ABS_GEQ_TWO;
     form1.Caption :=  'GLU_TESS_WINDING_ABS_GEQ_TWO';
  end;


 if (currentWinding = GLU_TESS_WINDING_ABS_GEQ_TWO) then
  begin
     currentWinding := GLU_TESS_WINDING_ODD;
     form1.Caption :=  'GLU_TESS_WINDING_ODD';
  end;

  makeNewLists();

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 f_Hdc := GetDC( handle );
 SetDCPixelFormat(f_Hdc,16,16);// Create a rendering context.
 initGL();
end;

procedure TForm1.FormResize(Sender: TObject);
begin
   wglMakeCurrent(f_Hdc,hrc); //activate the RC
     reshape( Width, Height);
   InvalidateRect(Handle, nil, False);// Draw the scene.
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 CleanUp(f_Hdc);// Clean up and terminate.
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 wglMakeCurrent(f_Hdc,hrc); //activate the RC
 display;                // Draw the scene
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  gluDeleteTess(tobj);
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  keyboard;
  InvalidateRect(Handle, nil, False);// Draw the scene.
end;

end.
