unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    CheckBox1: TCheckBox;
    GroupBox2: TGroupBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

Uses IniFiles;

{$R *.DFM}


{----------------------------------------------------------------}
{--- Form create : Load settings from INI file. if there are  ---}
{---   no settings, the default is assumed                    ---}
{----------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
var PluginIni : TIniFile;
    Path : String;
    P : Integer;
    Width : Integer;
begin
  // Get path to winamp plugin.ini file
  Path :=ParamStr(0);   // eg. 'c:\program files\winamp\winamp.exe'
  P :=Length(Path);
  while Path[P] <> '\' do
    Dec(P);
  Path :=Copy(Path, 1, P);
  Path :=Path + 'Plugins\';

  PluginIni := TIniFile.Create(Path + 'plugin.ini');

  // Get window settings
  Width :=PluginIni.ReadInteger('JansGL', 'Width', 800);
  if Width = 640 then
    RadioButton1.Checked :=TRUE
  else if Width = 800 then
    RadioButton2.Checked :=TRUE
  else if Width = 1024 then
    RadioButton3.Checked :=TRUE;

  CheckBox1.Checked :=PluginIni.ReadBool('JansGL', 'FullScreen', FALSE);

  // Get display settings
  CheckBox2.Checked :=PluginIni.ReadBool('JansGL', 'BackgroundBeat', TRUE);
  CheckBox3.Checked :=PluginIni.ReadBool('JansGL', 'BounceBeat', FALSE);

  PluginIni.Free;
end;


procedure TForm1.Button1Click(Sender: TObject);
var PluginIni : TIniFile;
    Path : String;
    P : Integer;
begin
  // Get path to winamp plugin.ini file
  Path :=ParamStr(0);   // eg. 'c:\program files\winamp\winamp.exe'
  P :=Length(Path);
  while Path[P] <> '\' do
    Dec(P);
  Path :=Copy(Path, 1, P);
  Path :=Path + 'Plugins\';

  PluginIni := TIniFile.Create(Path + 'plugin.ini');

  // Save the window size
  if RadioButton1.Checked then
  begin
    PluginIni.WriteInteger('JansGL', 'Width', 640);
    PluginIni.WriteInteger('JansGL', 'Height', 480);
  end;
  if RadioButton2.Checked then
  begin
    PluginIni.WriteInteger('JansGL', 'Width', 800);
    PluginIni.WriteInteger('JansGL', 'Height', 600);
  end;
  if RadioButton3.Checked then
  begin
    PluginIni.WriteInteger('JansGL', 'Width', 1024);
    PluginIni.WriteInteger('JansGL', 'Height', 768);
  end;

  // save fullscreen information
  PluginIni.WriteBool('JansGL', 'FullScreen', CheckBox1.Checked);

  // save background beat information
  PluginIni.WriteBool('JansGL', 'BackgroundBeat', CheckBox2.Checked);

  // save bounce beat information
  PluginIni.WriteBool('JansGL', 'BounceBeat', CheckBox3.Checked);

  PluginIni.Free;

  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Close;
end;


end.
